Index: trunk/src/VBox/Frontends/VirtualBox4/include/QIAbstractWizard.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/QIAbstractWizard.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/QIAbstractWizard.h	(revision 9716)
@@ -42,5 +42,5 @@
 class QITextEdit : public QTextEdit
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -79,5 +79,5 @@
 class QIAbstractWizard : public QDialog
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/QILabel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/QILabel.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/QILabel.h	(revision 9716)
@@ -35,5 +35,5 @@
 class QILabel: public QWidget
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/QILabel_p.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/QILabel_p.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/QILabel_p.h	(revision 9716)
@@ -33,5 +33,5 @@
 class QILabelPrivate: public QLabel
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/QIListView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/QIListView.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/QIListView.h	(revision 9716)
@@ -30,5 +30,5 @@
 class QIListView: public QListView
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -37,5 +37,5 @@
 protected slots:
     void focusChanged (QWidget *aOld, QWidget *aNow);
-}; 
+};
 
 class QIItemDelegate: public QItemDelegate
@@ -46,5 +46,5 @@
 
 protected:
-    void drawBackground (QPainter *aPainter, const QStyleOptionViewItem &aOption, 
+    void drawBackground (QPainter *aPainter, const QStyleOptionViewItem &aOption,
                          const QModelIndex &aIndex) const;
 };
Index: trunk/src/VBox/Frontends/VirtualBox4/include/QIMainDialog.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/QIMainDialog.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/QIMainDialog.h	(revision 9716)
@@ -34,5 +34,5 @@
 class QIMainDialog: public QMainWindow
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/QIStateIndicator.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/QIStateIndicator.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/QIStateIndicator.h	(revision 9716)
@@ -30,5 +30,5 @@
 class QIStateIndicator : public QFrame
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/QIStatusBar.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/QIStatusBar.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/QIStatusBar.h	(revision 9716)
@@ -31,5 +31,5 @@
 class QIStatusBar : public QStatusBar
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/QITreeWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/QITreeWidget.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/QITreeWidget.h	(revision 9716)
@@ -29,5 +29,5 @@
 class QITreeWidget: public QTreeWidget
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxAboutDlg.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxAboutDlg.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxAboutDlg.h	(revision 9716)
@@ -30,5 +30,5 @@
                      public Ui::VBoxAboutDlg
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxCloseVMDlg.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxCloseVMDlg.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxCloseVMDlg.h	(revision 9716)
@@ -31,5 +31,5 @@
                        public Ui::VBoxCloseVMDlg
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxConsoleWnd.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxConsoleWnd.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxConsoleWnd.h	(revision 9716)
@@ -57,5 +57,5 @@
 class VBoxConsoleWnd : public QIWithRetranslateUI2<QMainWindow>
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -349,5 +349,5 @@
 class VBoxSFDialog : public QIWithRetranslateUI<QDialog>
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxDiskImageManagerDlg.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxDiskImageManagerDlg.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxDiskImageManagerDlg.h	(revision 9716)
@@ -39,5 +39,5 @@
                                 public Ui::VBoxDiskImageManagerDlg
 {
-    Q_OBJECT;
+    Q_OBJECT
 
     enum TabIndex { HDTab = 0,
@@ -129,5 +129,5 @@
 
     void makeWarningMark (DiskImageItem *aItem, VBoxMedia::Status aStatus, VBoxDefs::DiskType aType) const;
-    
+
     static QString DVDImageUsage (const QUuid &aId, QString &aSnapshotUsage);
     static QString FloppyImageUsage (const QUuid &aId, QString &aSnapshotUsage);
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxDownloaderWgt.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxDownloaderWgt.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxDownloaderWgt.h	(revision 9716)
@@ -49,5 +49,5 @@
 class VBoxDownloaderWgt : public QIWithRetranslateUI<QWidget>
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxNewHDWzd.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxNewHDWzd.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxNewHDWzd.h	(revision 9716)
@@ -33,5 +33,5 @@
                      public Ui::VBoxNewHDWzd
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxNewVMWzd.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxNewVMWzd.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxNewVMWzd.h	(revision 9716)
@@ -33,5 +33,5 @@
                      public Ui::VBoxNewVMWzd
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxRegistrationDlg.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxRegistrationDlg.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxRegistrationDlg.h	(revision 9716)
@@ -38,5 +38,5 @@
                             public Ui::VBoxRegistrationDlg
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxSelectorWnd.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxSelectorWnd.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxSelectorWnd.h	(revision 9716)
@@ -47,5 +47,5 @@
 class VBoxSelectorWnd: public QIWithRetranslateUI2<QMainWindow>
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxSnapshotDetailsDlg.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxSnapshotDetailsDlg.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxSnapshotDetailsDlg.h	(revision 9716)
@@ -31,5 +31,5 @@
                                public Ui::VBoxSnapshotDetailsDlg
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxSnapshotsWgt.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxSnapshotsWgt.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxSnapshotsWgt.h	(revision 9716)
@@ -38,5 +38,5 @@
                          public Ui::VBoxSnapshotsWgt
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxTakeSnapshotDlg.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxTakeSnapshotDlg.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxTakeSnapshotDlg.h	(revision 9716)
@@ -30,5 +30,5 @@
                             public Ui::VBoxTakeSnapshotDlg
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMFirstRunWzd.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMFirstRunWzd.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMFirstRunWzd.h	(revision 9716)
@@ -33,5 +33,5 @@
                           public Ui::VBoxVMFirstRunWzd
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMInformationDlg.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMInformationDlg.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMInformationDlg.h	(revision 9716)
@@ -35,5 +35,5 @@
                              public Ui::VBoxVMInformationDlg
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMListView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMListView.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMListView.h	(revision 9716)
@@ -42,5 +42,5 @@
     QIcon osIcon() const { return mAccessible ? vboxGlobal().vmGuestOSTypeIcon (mOSTypeId) :QPixmap (":/os_unknown.png"); }
     QUuid id() const { return mId; }
-    
+
     QString sessionStateName() const;
     QIcon sessionStateIcon() const { return mAccessible ? vboxGlobal().toIcon (mState) : QPixmap (":/state_aborted_16px.png"); }
@@ -89,5 +89,5 @@
 class VBoxVMModel: public QAbstractListModel
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -138,5 +138,5 @@
 class VBoxVMListView: public QIListView
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -163,5 +163,5 @@
     void mousePressEvent (QMouseEvent *aEvent);
     bool selectCurrent();
-}; 
+};
 
 class VBoxVMItemPainter: public QIItemDelegate
@@ -181,7 +181,7 @@
     inline QIcon::Mode iconMode (QStyle::State aState) const
     {
-        if (!(aState & QStyle::State_Enabled)) 
+        if (!(aState & QStyle::State_Enabled))
             return QIcon::Disabled;
-        if (aState & QStyle::State_Selected) 
+        if (aState & QStyle::State_Selected)
             return QIcon::Selected;
         return QIcon::Normal;
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsAudio.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsAudio.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsAudio.h	(revision 9716)
@@ -29,5 +29,5 @@
 class VBoxVMSettingsAudio : public QWidget, public Ui::VBoxVMSettingsAudio
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsCD.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsCD.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsCD.h	(revision 9716)
@@ -30,8 +30,8 @@
 class QIWidgetValidator;
 
-class VBoxVMSettingsCD : public QWidget, 
+class VBoxVMSettingsCD : public QWidget,
                          public Ui::VBoxVMSettingsCD
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsFD.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsFD.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsFD.h	(revision 9716)
@@ -30,8 +30,8 @@
 class QIWidgetValidator;
 
-class VBoxVMSettingsFD : public QWidget, 
+class VBoxVMSettingsFD : public QWidget,
                          public Ui::VBoxVMSettingsFD
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsGeneral.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsGeneral.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsGeneral.h	(revision 9716)
@@ -30,8 +30,8 @@
 class QIWidgetValidator;
 
-class VBoxVMSettingsGeneral : public QWidget, 
+class VBoxVMSettingsGeneral : public QWidget,
                               public Ui::VBoxVMSettingsGeneral
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsHD.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsHD.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsHD.h	(revision 9716)
@@ -135,5 +135,5 @@
 class HDItemsModel : public QAbstractTableModel
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -179,5 +179,5 @@
 class HDSltEditor : public QComboBox
 {
-    Q_OBJECT;
+    Q_OBJECT
     Q_PROPERTY (QVariant slot READ slot WRITE setSlot USER true);
 
@@ -207,5 +207,5 @@
 class HDVdiEditor : public VBoxMediaComboBox
 {
-    Q_OBJECT;
+    Q_OBJECT
     Q_PROPERTY (QVariant vdi READ vdi WRITE setVdi USER true);
 
@@ -239,5 +239,5 @@
 class HDSlotUniquizer : public QObject
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -274,8 +274,8 @@
 
 /** QWidget class reimplementation used as hard disks settings */
-class VBoxVMSettingsHD : public QWidget, 
+class VBoxVMSettingsHD : public QWidget,
                          public Ui::VBoxVMSettingsHD
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsNetwork.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsNetwork.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsNetwork.h	(revision 9716)
@@ -30,8 +30,8 @@
 class QIWidgetValidator;
 
-class VBoxVMSettingsNetwork : public QWidget, 
+class VBoxVMSettingsNetwork : public QWidget,
                               public Ui::VBoxVMSettingsNetwork
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsParallel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsParallel.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsParallel.h	(revision 9716)
@@ -29,8 +29,8 @@
 class VBoxVMSettingsDlg;
 
-class VBoxVMSettingsParallel : public QWidget, 
+class VBoxVMSettingsParallel : public QWidget,
                                public Ui::VBoxVMSettingsParallel
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsSF.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsSF.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsSF.h	(revision 9716)
@@ -51,5 +51,5 @@
                          public Ui::VBoxVMSettingsSF
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -124,5 +124,5 @@
 class VBoxAddSFDialog : public QIWithRetranslateUI<QDialog>
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsSerial.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsSerial.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsSerial.h	(revision 9716)
@@ -29,8 +29,8 @@
 class VBoxVMSettingsDlg;
 
-class VBoxVMSettingsSerial : public QWidget, 
+class VBoxVMSettingsSerial : public QWidget,
                              public Ui::VBoxVMSettingsSerial
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsUSB.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsUSB.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsUSB.h	(revision 9716)
@@ -31,8 +31,8 @@
 class VBoxUSBMenu;
 
-class VBoxVMSettingsUSB : public QWidget, 
+class VBoxVMSettingsUSB : public QWidget,
                           public Ui::VBoxVMSettingsUSB
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsUtils.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsUtils.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsUtils.h	(revision 9716)
@@ -54,5 +54,5 @@
 class BootItemsTable : public QTreeWidget
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -201,5 +201,5 @@
 class QITableView : public QTableView
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsVRDP.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsVRDP.h	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsVRDP.h	(revision 9716)
@@ -30,8 +30,8 @@
 class QIWidgetValidator;
 
-class VBoxVMSettingsVRDP : public QWidget, 
+class VBoxVMSettingsVRDP : public QWidget,
                            public Ui::VBoxVMSettingsVRDP
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSelectorWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSelectorWnd.cpp	(revision 9688)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSelectorWnd.cpp	(revision 9716)
@@ -56,5 +56,5 @@
 class VBoxVMDetailsView : public QIWithRetranslateUI<QStackedWidget>
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public:
@@ -214,5 +214,5 @@
 class VBoxVMDescriptionPage : public QIWithRetranslateUI<QWidget>
 {
-    Q_OBJECT;
+    Q_OBJECT
 
 public: